package com.ruoyi.frequency.bondrecord.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.controller.req.BondPayReq;
import com.ruoyi.controller.req.BondRecordPageReq;
import com.ruoyi.frequency.bondrecord.entity.BondRecord;
import com.ruoyi.response.ResponseData;
import com.ruoyi.vo.UserVo;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * 保证金记录Service接口
 * 
 * @author liwenlong
 * @date 2023-10-18
 */
public interface BondRecordService extends IService<BondRecord>
{
    /**
     * 查询保证金记录
     * 
     * @param id 保证金记录主键
     * @return 保证金记录
     */
    public BondRecord selectBondRecordById(Long id);

    /**
     * 查询保证金记录列表
     * 
     * @param bondRecord 保证金记录
     * @return 保证金记录集合
     */
    public List<BondRecord> selectBondRecordList(BondRecord bondRecord);

    /**
     * 新增保证金记录
     * 
     * @param bondRecord 保证金记录
     * @return 结果
     */
    public int insertBondRecord(BondRecord bondRecord);

    /**
     * 修改保证金记录
     * 
     * @param bondRecord 保证金记录
     * @return 结果
     */
    public int updateBondRecord(BondRecord bondRecord);

    /**
     * 批量删除保证金记录
     * 
     * @param ids 需要删除的保证金记录主键集合
     * @return 结果
     */
    public int deleteBondRecordByIds(Long[] ids);

    /**
     * 删除保证金记录信息
     * 
     * @param id 保证金记录主键
     * @return 结果
     */
    public int deleteBondRecordById(Long id);

    ResponseData bondPay(BondPayReq req, UserVo userVo);

    ResponseData bondRecordPage(BondRecordPageReq req, UserVo userVo);


    /**
     * 保证金支付宝回调
     * @param request
     * @param response
     * @return
     */
    ResponseData bondAliNotify(HttpServletRequest request, HttpServletResponse response);

    /**
     * 保证金微信回调
     * @param request
     * @param response
     * @return
     */
    ResponseData bondWxNotify(HttpServletRequest request, HttpServletResponse response);

    ResponseData bondRecordDetail(Long id, UserVo userVo);

    ResponseData bondLakalaNotify(Map<String, String> paramMap);
}
